﻿//----------------------
// <auto-generated>
//     Generated using the NSwag toolchain v8.5.6214.25340 (NJsonSchema v7.3.6214.20986) (http://NSwag.org)
// </auto-generated>
//----------------------

using System;
using System.Net;
using System.Net.Http;

namespace CSharp_Reference_App
{
#pragma warning disable // Disable all warnings

    [System.CodeDom.Compiler.GeneratedCode("NSwag", "8.5.6214.25340")]
    public partial class ClientApi
    {
        private string _baseUrl = "";
        private readonly CookieContainer _cookieContainer = new CookieContainer();
        private readonly HttpClientHandler _httpClientHandler;

        public ClientApi(string baseUrl)
        {
            BaseUrl = baseUrl;
            _httpClientHandler = new HttpClientHandler
            {
                CookieContainer = _cookieContainer,
                UseCookies = true
            };
        }

        public string BaseUrl
        {
            get { return _baseUrl; }
            set { _baseUrl = value; }
        }

        protected virtual HttpClient CreateHttpClient()
        {
            return new System.Net.Http.HttpClient(new HttpClientHandler
            {
                CookieContainer = _cookieContainer,
                UseCookies = true
            })
            { BaseAddress = new Uri(BaseUrl) };
        }


        partial void PrepareRequest(System.Net.Http.HttpClient request, ref string url);

        partial void ProcessResponse(System.Net.Http.HttpClient request, System.Net.Http.HttpResponseMessage response);

        /// <summary>TODO</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurementType</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.Generic.Dictionary<string, Histogram>> GetMeasurementSummaryAsync(long datasetId, long measurementTypeId, long? split)
        {
            return GetMeasurementSummaryAsync(datasetId, measurementTypeId, split, System.Threading.CancellationToken.None);
        }

        /// <summary>TODO</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurementType</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.Generic.Dictionary<string, Histogram>> GetMeasurementSummaryAsync(long datasetId, long measurementTypeId, long? split, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}?", BaseUrl, "api/charts/datasets/{datasetId}/measurements/{measurementTypeId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            if (split != null)
                url_ += string.Format("split={0}&", System.Uri.EscapeDataString(split.Value.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.Generic.Dictionary<string, Histogram>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.Generic.Dictionary<string, Histogram>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.Generic.Dictionary<string, Histogram>);
            }
        }

        /// <summary>TODO</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurementType</param>
        /// <param name="plotId">id of the property to plot</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.Generic.Dictionary<string, PropertySummaryChart>> GetPropertyPlotAsync(long datasetId, long measurementTypeId, long plotId, long? split)
        {
            return GetPropertyPlotAsync(datasetId, measurementTypeId, plotId, split, System.Threading.CancellationToken.None);
        }

        /// <summary>TODO</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurementType</param>
        /// <param name="plotId">id of the property to plot</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.Generic.Dictionary<string, PropertySummaryChart>> GetPropertyPlotAsync(long datasetId, long measurementTypeId, long plotId, long? split, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}?", BaseUrl, "api/charts/datasets/{datasetId}/measurements/{measurementTypeId}/plot/{plotId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            if (plotId == null)
                throw new System.ArgumentNullException("plotId");
            url_ = url_.Replace("{plotId}", System.Uri.EscapeDataString(plotId.ToString()));

            if (split != null)
                url_ += string.Format("split={0}&", System.Uri.EscapeDataString(split.Value.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.Generic.Dictionary<string, PropertySummaryChart>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.Generic.Dictionary<string, PropertySummaryChart>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.Generic.Dictionary<string, PropertySummaryChart>);
            }
        }

        /// <summary>Fetch a dataset by id</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<Dataset> GetDatasetByIdAsync(long datasetId)
        {
            return GetDatasetByIdAsync(datasetId, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch a dataset by id</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<Dataset> GetDatasetByIdAsync(long datasetId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(Dataset);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<Dataset>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(Dataset);
            }
        }

        /// <summary>Updates a dataset (post-MVP)</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="newValue">The new value for the dataset</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<Dataset> UpdateDatasetAsync(long datasetId, Dataset newValue)
        {
            return UpdateDatasetAsync(datasetId, newValue, System.Threading.CancellationToken.None);
        }

        /// <summary>Updates a dataset (post-MVP)</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="newValue">The new value for the dataset</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<Dataset> UpdateDatasetAsync(long datasetId, Dataset newValue, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(newValue));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("PUT");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(Dataset);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<Dataset>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(Dataset);
            }
        }

        /// <summary>Delete a dataset (post-MVP)</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <returns>No Content</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task DeleteDatasetAsync(long datasetId)
        {
            return DeleteDatasetAsync(datasetId, System.Threading.CancellationToken.None);
        }

        /// <summary>Delete a dataset (post-MVP)</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>No Content</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task DeleteDatasetAsync(long datasetId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("DELETE");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <summary>Fetch a dataset by name</summary>
        /// <param name="datasetName">name of the dataset</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<Dataset> GetDatasetByNameAsync(string datasetName)
        {
            return GetDatasetByNameAsync(datasetName, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch a dataset by name</summary>
        /// <param name="datasetName">name of the dataset</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<Dataset> GetDatasetByNameAsync(string datasetName, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/query/{datasetName}");

            if (datasetName == null)
                throw new System.ArgumentNullException("datasetName");
            url_ = url_.Replace("{datasetName}", System.Uri.EscapeDataString(datasetName.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(Dataset);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<Dataset>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(Dataset);
            }
        }

        /// <summary>Fetch all datasets (post-MVP)</summary>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Dataset>> GetAllDatasetsAsync()
        {
            return GetAllDatasetsAsync(System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch all datasets (post-MVP)</summary>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Dataset>> GetAllDatasetsAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<Dataset>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<Dataset>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<Dataset>);
            }
        }

        /// <summary>Create a new dataset (post-MVP)</summary>
        /// <param name="dataset">The dataset to create</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<Dataset> CreateDatasetAsync(Dataset dataset)
        {
            return CreateDatasetAsync(dataset, System.Threading.CancellationToken.None);
        }

        /// <summary>Create a new dataset (post-MVP)</summary>
        /// <param name="dataset">The dataset to create</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<Dataset> CreateDatasetAsync(Dataset dataset, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(dataset));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(Dataset);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<Dataset>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(Dataset);
            }
        }

        /// <summary>Imports a dataset</summary>
        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task ImportDatasetAsync()
        {
            return ImportDatasetAsync(System.Threading.CancellationToken.None);
        }

        /// <summary>Imports a dataset</summary>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task ImportDatasetAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/bulk");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(string.Empty);
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <summary>Fetch all property types for a given measurement type</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurement type to report</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>> GetPropertyTypesForMeasurementAsync(long datasetId, long measurementTypeId)
        {
            return GetPropertyTypesForMeasurementAsync(datasetId, measurementTypeId, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch all property types for a given measurement type</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurement type to report</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>> GetPropertyTypesForMeasurementAsync(long datasetId, long measurementTypeId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurements/{measurementTypeId}/property-types");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>);
            }
        }

        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Measurement>> GetAllMeasurementsAsync(long datasetId)
        {
            return GetAllMeasurementsAsync(datasetId, System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Measurement>> GetAllMeasurementsAsync(long datasetId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurements");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<Measurement>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<Measurement>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<Measurement>);
            }
        }

        /// <summary>Create a measurement</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurement">The measurement to create</param>
        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task CreateMeasurementAsync(long datasetId, Measurement measurement)
        {
            return CreateMeasurementAsync(datasetId, measurement, System.Threading.CancellationToken.None);
        }

        /// <summary>Create a measurement</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurement">The measurement to create</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task CreateMeasurementAsync(long datasetId, Measurement measurement, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurements");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(measurement));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <summary>Create multiple measurements</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurements">The measurements to create</param>
        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task CreateMeasurementsAsync(long datasetId, System.Collections.Generic.IEnumerable<Measurement> measurements)
        {
            return CreateMeasurementsAsync(datasetId, measurements, System.Threading.CancellationToken.None);
        }

        /// <summary>Create multiple measurements</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurements">The measurements to create</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task CreateMeasurementsAsync(long datasetId, System.Collections.Generic.IEnumerable<Measurement> measurements, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurements/bulk");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(measurements));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <summary>Fetches all measurements of the given type in the dataset.</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">The measurement type to query</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Measurement>> GetMeasurementsAsync(long datasetId, long measurementTypeId)
        {
            return GetMeasurementsAsync(datasetId, measurementTypeId, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetches all measurements of the given type in the dataset.</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">The measurement type to query</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Measurement>> GetMeasurementsAsync(long datasetId, long measurementTypeId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurements/{measurementTypeId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<Measurement>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<Measurement>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<Measurement>);
            }
        }

        /// <summary>Query for a list of measurements matching the given properties.  This will return actual measurements and not just values</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">The measurement type to query</param>
        /// <param name="properties">The properties to filter the query on</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Measurement>> QueryForMeasurementsAsync(long datasetId, long measurementTypeId, System.Collections.Generic.IEnumerable<Property> properties)
        {
            return QueryForMeasurementsAsync(datasetId, measurementTypeId, properties, System.Threading.CancellationToken.None);
        }

        /// <summary>Query for a list of measurements matching the given properties.  This will return actual measurements and not just values</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">The measurement type to query</param>
        /// <param name="properties">The properties to filter the query on</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<Measurement>> QueryForMeasurementsAsync(long datasetId, long measurementTypeId, System.Collections.Generic.IEnumerable<Property> properties, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurements/{measurementTypeId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(properties));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<Measurement>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<Measurement>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<Measurement>);
            }
        }

        /// <summary>Query for a list of measurements using a property 'key'.  This method only checks to see if the measurement exists.</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">The measurement type to query</param>
        /// <param name="propertyTypeId">The property type to query</param>
        /// <param name="values">The values to query</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<bool>> QueryForMeasurementExistenceByKeyAsync(long datasetId, long measurementTypeId, long propertyTypeId, System.Collections.Generic.IEnumerable<string> values)
        {
            return QueryForMeasurementExistenceByKeyAsync(datasetId, measurementTypeId, propertyTypeId, values, System.Threading.CancellationToken.None);
        }

        /// <summary>Query for a list of measurements using a property 'key'.  This method only checks to see if the measurement exists.</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">The measurement type to query</param>
        /// <param name="propertyTypeId">The property type to query</param>
        /// <param name="values">The values to query</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<bool>> QueryForMeasurementExistenceByKeyAsync(long datasetId, long measurementTypeId, long propertyTypeId, System.Collections.Generic.IEnumerable<string> values, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurements/{measurementTypeId}/query/{propertyTypeId}/exists");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            if (propertyTypeId == null)
                throw new System.ArgumentNullException("propertyTypeId");
            url_ = url_.Replace("{propertyTypeId}", System.Uri.EscapeDataString(propertyTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(values));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<bool>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<bool>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<bool>);
            }
        }

        /// <summary>Fetch a summary of all measurement types defined for an dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<MeasurementTypeSummary>> GetMeasurementTypeSummariesForDatasetAsync(long datasetId)
        {
            return GetMeasurementTypeSummariesForDatasetAsync(datasetId, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch a summary of all measurement types defined for an dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<MeasurementTypeSummary>> GetMeasurementTypeSummariesForDatasetAsync(long datasetId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurement-types/summary");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<MeasurementTypeSummary>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<MeasurementTypeSummary>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<MeasurementTypeSummary>);
            }
        }

        /// <summary>Fetch all measurement types defined for an dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<MeasurementType>> GetMeasurementTypesForDatasetAsync(long datasetId)
        {
            return GetMeasurementTypesForDatasetAsync(datasetId, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch all measurement types defined for an dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<MeasurementType>> GetMeasurementTypesForDatasetAsync(long datasetId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurement-types");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<MeasurementType>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<MeasurementType>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<MeasurementType>);
            }
        }

        /// <summary>Create new measurement types for a dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementsToCreate">An array of measurements to create</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<MeasurementType>> CreateMeasurementTypesForDatasetAsync(long datasetId, System.Collections.Generic.IEnumerable<MeasurementType> measurementsToCreate)
        {
            return CreateMeasurementTypesForDatasetAsync(datasetId, measurementsToCreate, System.Threading.CancellationToken.None);
        }

        /// <summary>Create new measurement types for a dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementsToCreate">An array of measurements to create</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<MeasurementType>> CreateMeasurementTypesForDatasetAsync(long datasetId, System.Collections.Generic.IEnumerable<MeasurementType> measurementsToCreate, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurement-types");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(measurementsToCreate));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<MeasurementType>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<MeasurementType>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<MeasurementType>);
            }
        }

        /// <summary>Get a measurement type by id</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurement type</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<MeasurementType> GetMeasurementTypeAsync(long datasetId, long measurementTypeId)
        {
            return GetMeasurementTypeAsync(datasetId, measurementTypeId, System.Threading.CancellationToken.None);
        }

        /// <summary>Get a measurement type by id</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurement type</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<MeasurementType> GetMeasurementTypeAsync(long datasetId, long measurementTypeId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurement-types/{measurementTypeId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(MeasurementType);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<MeasurementType>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(MeasurementType);
            }
        }

        /// <summary>Update a measurement type</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurement type</param>
        /// <param name="newValue">New value for the measurement type</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<MeasurementType> UpdateMeasurementTypeAsync(long datasetId, long measurementTypeId, MeasurementType newValue)
        {
            return UpdateMeasurementTypeAsync(datasetId, measurementTypeId, newValue, System.Threading.CancellationToken.None);
        }

        /// <summary>Update a measurement type</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="measurementTypeId">id of the measurement type</param>
        /// <param name="newValue">New value for the measurement type</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<MeasurementType> UpdateMeasurementTypeAsync(long datasetId, long measurementTypeId, MeasurementType newValue, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/measurement-types/{measurementTypeId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (measurementTypeId == null)
                throw new System.ArgumentNullException("measurementTypeId");
            url_ = url_.Replace("{measurementTypeId}", System.Uri.EscapeDataString(measurementTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(newValue));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("PUT");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(MeasurementType);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<MeasurementType>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(MeasurementType);
            }
        }

        /// <summary>Fetch a property type by id</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="propertyTypeId">id of the property type</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>> GetPropertyTypeAsync(long datasetId, long propertyTypeId)
        {
            return GetPropertyTypeAsync(datasetId, propertyTypeId, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch a property type by id</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="propertyTypeId">id of the property type</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>> GetPropertyTypeAsync(long datasetId, long propertyTypeId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/property-types/{propertyTypeId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (propertyTypeId == null)
                throw new System.ArgumentNullException("propertyTypeId");
            url_ = url_.Replace("{propertyTypeId}", System.Uri.EscapeDataString(propertyTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<PropertyTypeSummary>);
            }
        }

        /// <summary>Update property type</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="propertyTypeId">id of the property type to update</param>
        /// <param name="newValue">new value of the property type</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<PropertyType> UpdatePropertyTypeAsync(long datasetId, long propertyTypeId, PropertyType newValue)
        {
            return UpdatePropertyTypeAsync(datasetId, propertyTypeId, newValue, System.Threading.CancellationToken.None);
        }

        /// <summary>Update property type</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="propertyTypeId">id of the property type to update</param>
        /// <param name="newValue">new value of the property type</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<PropertyType> UpdatePropertyTypeAsync(long datasetId, long propertyTypeId, PropertyType newValue, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/property-types/{propertyTypeId}");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            if (propertyTypeId == null)
                throw new System.ArgumentNullException("propertyTypeId");
            url_ = url_.Replace("{propertyTypeId}", System.Uri.EscapeDataString(propertyTypeId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(newValue));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("PUT");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(PropertyType);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<PropertyType>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(PropertyType);
            }
        }

        /// <summary>Fetch all property types defined for a dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyType>> GetPropertyTypesAsync(long datasetId)
        {
            return GetPropertyTypesAsync(datasetId, System.Threading.CancellationToken.None);
        }

        /// <summary>Fetch all property types defined for a dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyType>> GetPropertyTypesAsync(long datasetId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/property-types");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<PropertyType>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<PropertyType>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<PropertyType>);
            }
        }

        /// <summary>Create new property types for an dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="propertyTypesToCreate">An array of property types to create</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyType>> CreatePropertyTypesForDatasetAsync(long datasetId, System.Collections.Generic.IEnumerable<PropertyType> propertyTypesToCreate)
        {
            return CreatePropertyTypesForDatasetAsync(datasetId, propertyTypesToCreate, System.Threading.CancellationToken.None);
        }

        /// <summary>Create new property types for an dataset</summary>
        /// <param name="datasetId">id of the dataset</param>
        /// <param name="propertyTypesToCreate">An array of property types to create</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<System.Collections.ObjectModel.ObservableCollection<PropertyType>> CreatePropertyTypesForDatasetAsync(long datasetId, System.Collections.Generic.IEnumerable<PropertyType> propertyTypesToCreate, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/datasets/{datasetId}/property-types");

            if (datasetId == null)
                throw new System.ArgumentNullException("datasetId");
            url_ = url_.Replace("{datasetId}", System.Uri.EscapeDataString(datasetId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(propertyTypesToCreate));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(System.Collections.ObjectModel.ObservableCollection<PropertyType>);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<System.Collections.ObjectModel.ObservableCollection<PropertyType>>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(System.Collections.ObjectModel.ObservableCollection<PropertyType>);
            }
        }

        /// <returns>No Content</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task ApiResetPostAsync()
        {
            return ApiResetPostAsync(System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>No Content</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task ApiResetPostAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/reset");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(string.Empty);
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<string> GetVersionAsync()
        {
            return GetVersionAsync(System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<string> GetVersionAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/configuration/version");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(string);
            }
        }

        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<DatabaseConfig> GetDatabaseConfigurationAsync()
        {
            return GetDatabaseConfigurationAsync(System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<DatabaseConfig> GetDatabaseConfigurationAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/configuration/database");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(DatabaseConfig);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<DatabaseConfig>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(DatabaseConfig);
            }
        }

        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<DatabaseConfig> SetDatabaseConfigurationAsync(DatabaseConfig config)
        {
            return SetDatabaseConfigurationAsync(config, System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<DatabaseConfig> SetDatabaseConfigurationAsync(DatabaseConfig config, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/configuration/database");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(config));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(DatabaseConfig);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<DatabaseConfig>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(DatabaseConfig);
            }
        }

        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<string> CheckDatabaseBootstrapAsync()
        {
            return CheckDatabaseBootstrapAsync(System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>OK</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<string> CheckDatabaseBootstrapAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/configuration/database/bootstrap");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(string);
            }
        }

        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task BootstrapDatabaseAsync()
        {
            return BootstrapDatabaseAsync(System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>NoContent</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task BootstrapDatabaseAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/configuration/database/bootstrap");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(string.Empty);
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<string> GetLoginRecordsAsync()
        {
            return GetLoginRecordsAsync(System.Threading.CancellationToken.None);
        }

        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<string> GetLoginRecordsAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/logins");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(string);
            }
        }

        /// <summary>Fetches all users</summary>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<string> GetUsersAsync()
        {
            return GetUsersAsync(System.Threading.CancellationToken.None);
        }

        /// <summary>Fetches all users</summary>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<string> GetUsersAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(string);
            }
        }

        /// <summary>Creates a user</summary>
        /// <param name="user">The user to create</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<User> CreateUserAsync(User user)
        {
            return CreateUserAsync(user, System.Threading.CancellationToken.None);
        }

        /// <summary>Creates a user</summary>
        /// <param name="user">The user to create</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<User> CreateUserAsync(User user, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(user));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(User);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<User>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(User);
            }
        }

        /// <summary>Deletes a user</summary>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task DeleteUserAsync(int userId)
        {
            return DeleteUserAsync(userId, System.Threading.CancellationToken.None);
        }

        /// <summary>Deletes a user</summary>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task DeleteUserAsync(int userId, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/{userId}");

            if (userId == null)
                throw new System.ArgumentNullException("userId");
            url_ = url_.Replace("{userId}", System.Uri.EscapeDataString(userId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("DELETE");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ == "404")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                    throw new SwaggerException<string>("No user found with given id", status_, responseData_, result_, null);
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <summary>Resets a user's password to the given value</summary>
        /// <param name="userId">Id of the user to change password for</param>
        /// <param name="password">New password value</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task ResetUserPasswordAsync(int userId, string password)
        {
            return ResetUserPasswordAsync(userId, password, System.Threading.CancellationToken.None);
        }

        /// <summary>Resets a user's password to the given value</summary>
        /// <param name="userId">Id of the user to change password for</param>
        /// <param name="password">New password value</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task ResetUserPasswordAsync(int userId, string password, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/{userId}/password");

            if (userId == null)
                throw new System.ArgumentNullException("userId");
            url_ = url_.Replace("{userId}", System.Uri.EscapeDataString(userId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(password));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ == "404")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                    throw new SwaggerException<string>("No user found with given id", status_, responseData_, result_, null);
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <summary>Makes a user an administrator or non-administrator</summary>
        /// <param name="userId">Id of the user to give admin privilege</param>
        /// <param name="isAdmin">Whether or not the user should be an admin</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<string> SetAdministratorPrivilegeAsync(int userId, string isAdmin)
        {
            return SetAdministratorPrivilegeAsync(userId, isAdmin, System.Threading.CancellationToken.None);
        }

        /// <summary>Makes a user an administrator or non-administrator</summary>
        /// <param name="userId">Id of the user to give admin privilege</param>
        /// <param name="isAdmin">Whether or not the user should be an admin</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Success</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<string> SetAdministratorPrivilegeAsync(int userId, string isAdmin, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/{userId}/is-admin");

            if (userId == null)
                throw new System.ArgumentNullException("userId");
            url_ = url_.Replace("{userId}", System.Uri.EscapeDataString(userId.ToString()));

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(isAdmin));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    throw new SwaggerException("No Content", status_, responseData_, null);
                }
                else
                if (status_ == "200")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ == "400")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                    throw new SwaggerException<string>("No user found with given id", status_, responseData_, result_, null);
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(string);
            }
        }

        /// <summary>Fetches the logged in user</summary>
        /// <returns>The logged in user</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<string> GetLoggedInUserAsync()
        {
            return GetLoggedInUserAsync(System.Threading.CancellationToken.None);
        }

        /// <summary>Fetches the logged in user</summary>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>The logged in user</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<string> GetLoggedInUserAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/current");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("GET");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ == "409")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                    throw new SwaggerException<string>("No user logged in", status_, responseData_, result_, null);
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(string);
            }
        }

        /// <summary>Logs in a user</summary>
        /// <param name="credentials">The user's credentials</param>
        /// <returns>The logged in user</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task<User> LoginAsync(UsernamePasswordCredentials credentials)
        {
            return LoginAsync(credentials, System.Threading.CancellationToken.None);
        }

        /// <summary>Logs in a user</summary>
        /// <param name="credentials">The user's credentials</param>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>The logged in user</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task<User> LoginAsync(UsernamePasswordCredentials credentials, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/current");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(credentials));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "200")
                {
                    var result_ = default(User);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<User>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                        return result_;
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                }
                else
                if (status_ == "401")
                {
                    var result_ = default(string);
                    try
                    {
                        if (responseData_.Length > 0)
                            result_ = Newtonsoft.Json.JsonConvert.DeserializeObject<string>(System.Text.Encoding.UTF8.GetString(responseData_, 0, responseData_.Length));
                    }
                    catch (System.Exception exception)
                    {
                        throw new SwaggerException("Could not deserialize the response body.", status_, responseData_, exception);
                    }
                    throw new SwaggerException<string>("Could not login", status_, responseData_, result_, null);
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);

                return default(User);
            }
        }

        /// <summary>Logs out the current user</summary>
        /// <returns>Logout successful</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task LogoutAsync()
        {
            return LogoutAsync(System.Threading.CancellationToken.None);
        }

        /// <summary>Logs out the current user</summary>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Logout successful</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task LogoutAsync(System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/current");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                request_.Method = new System.Net.Http.HttpMethod("DELETE");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ == "401")
                {
                    throw new SwaggerException("Not logged in", status_, responseData_, null);
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

        /// <summary>Updates the current user's password</summary>
        /// <returns>Password successfully updated</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public System.Threading.Tasks.Task UpdateCurrentUsersPasswordAsync(UsernamePasswordCredentials credentials)
        {
            return UpdateCurrentUsersPasswordAsync(credentials, System.Threading.CancellationToken.None);
        }

        /// <summary>Updates the current user's password</summary>
        /// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation.</param>
        /// <returns>Password successfully updated</returns>
        /// <exception cref="SwaggerException">A server side error occurred.</exception>
        public async System.Threading.Tasks.Task UpdateCurrentUsersPasswordAsync(UsernamePasswordCredentials credentials, System.Threading.CancellationToken cancellationToken)
        {
            var url_ = string.Format("{0}/{1}", BaseUrl, "api/users/current/password");

            using (var client_ = CreateHttpClient())
            {
                var request_ = new System.Net.Http.HttpRequestMessage();
                PrepareRequest(client_, ref url_);
                var content_ = new System.Net.Http.StringContent(Newtonsoft.Json.JsonConvert.SerializeObject(credentials));
                content_.Headers.ContentType.MediaType = "application/json";
                request_.Content = content_;
                request_.Method = new System.Net.Http.HttpMethod("POST");
                request_.RequestUri = new System.Uri(url_, System.UriKind.RelativeOrAbsolute);
                request_.Headers.Accept.Add(new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json"));
                var response_ = await client_.SendAsync(request_, System.Net.Http.HttpCompletionOption.ResponseContentRead, cancellationToken).ConfigureAwait(false);
                ProcessResponse(client_, response_);

                var responseData_ = await response_.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
                var status_ = ((int)response_.StatusCode).ToString();

                if (status_ == "204")
                {
                    return;
                }
                else
                if (status_ != "200" && status_ != "204")
                    throw new SwaggerException("The HTTP status code of the response was not expected (" + (int)response_.StatusCode + ").", status_, responseData_, null);
            }
        }

    }



    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class Histogram : System.ComponentModel.INotifyPropertyChanged
    {
        private System.Collections.ObjectModel.ObservableCollection<HistogramBucket> _buckets;

        /// <summary>The buckets of the histogram (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("buckets", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public System.Collections.ObjectModel.ObservableCollection<HistogramBucket> Buckets
        {
            get { return _buckets; }
            set
            {
                if (_buckets != value)
                {
                    _buckets = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static Histogram FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<Histogram>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class HistogramBucket : System.ComponentModel.INotifyPropertyChanged
    {
        private double? _lowerBound;
        private double? _upperBound;
        private int? _count;

        /// <summary>Lower bound of the bucket (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("lowerBound", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? LowerBound
        {
            get { return _lowerBound; }
            set
            {
                if (_lowerBound != value)
                {
                    _lowerBound = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>Upper bound of the bucket (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("upperBound", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? UpperBound
        {
            get { return _upperBound; }
            set
            {
                if (_upperBound != value)
                {
                    _upperBound = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>Number of measurements in bucket (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("count", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public int? Count
        {
            get { return _count; }
            set
            {
                if (_count != value)
                {
                    _count = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static HistogramBucket FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<HistogramBucket>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class PropertySummaryChart : System.ComponentModel.INotifyPropertyChanged
    {
        private System.Collections.ObjectModel.ObservableCollection<string> _xValues;
        private System.Collections.ObjectModel.ObservableCollection<PropertySummaryValues> _yValues;

        [Newtonsoft.Json.JsonProperty("xValues", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public System.Collections.ObjectModel.ObservableCollection<string> XValues
        {
            get { return _xValues; }
            set
            {
                if (_xValues != value)
                {
                    _xValues = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("yValues", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public System.Collections.ObjectModel.ObservableCollection<PropertySummaryValues> YValues
        {
            get { return _yValues; }
            set
            {
                if (_yValues != value)
                {
                    _yValues = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static PropertySummaryChart FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<PropertySummaryChart>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class PropertySummaryValues : System.ComponentModel.INotifyPropertyChanged
    {
        private double? _minimum;
        private double? _lowerQuantile;
        private double? _upperQuantile;
        private double? _maximum;
        private double? _median;
        private double? _mean;

        [Newtonsoft.Json.JsonProperty("minimum", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? Minimum
        {
            get { return _minimum; }
            set
            {
                if (_minimum != value)
                {
                    _minimum = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("lowerQuantile", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? LowerQuantile
        {
            get { return _lowerQuantile; }
            set
            {
                if (_lowerQuantile != value)
                {
                    _lowerQuantile = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("upperQuantile", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? UpperQuantile
        {
            get { return _upperQuantile; }
            set
            {
                if (_upperQuantile != value)
                {
                    _upperQuantile = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("maximum", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? Maximum
        {
            get { return _maximum; }
            set
            {
                if (_maximum != value)
                {
                    _maximum = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("median", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? Median
        {
            get { return _median; }
            set
            {
                if (_median != value)
                {
                    _median = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("mean", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? Mean
        {
            get { return _mean; }
            set
            {
                if (_mean != value)
                {
                    _mean = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static PropertySummaryValues FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<PropertySummaryValues>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class Dataset : System.ComponentModel.INotifyPropertyChanged
    {
        private long? _id;
        private string _name;
        private int? _measurementCount;

        /// <summary>Id of the dataset (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("id", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public long? Id
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                    _id = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The name of the dataset (required on create)</summary>
        [Newtonsoft.Json.JsonProperty("name", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Name
        {
            get { return _name; }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The number of sessions in the dataset (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("measurementCount", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public int? MeasurementCount
        {
            get { return _measurementCount; }
            set
            {
                if (_measurementCount != value)
                {
                    _measurementCount = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static Dataset FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<Dataset>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class PropertyTypeSummary : System.ComponentModel.INotifyPropertyChanged
    {
        private PropertyType _propertyType;
        private System.Collections.ObjectModel.ObservableCollection<string> _values;

        /// <summary>The property type being reported (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("propertyType", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public PropertyType PropertyType
        {
            get { return _propertyType; }
            set
            {
                if (_propertyType != value)
                {
                    _propertyType = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>Possible property values</summary>
        [Newtonsoft.Json.JsonProperty("values", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public System.Collections.ObjectModel.ObservableCollection<string> Values
        {
            get { return _values; }
            set
            {
                if (_values != value)
                {
                    _values = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static PropertyTypeSummary FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<PropertyTypeSummary>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class PropertyType : System.ComponentModel.INotifyPropertyChanged
    {
        private long? _id;
        private string _name;
        private string _group;
        private PropertyTypeFormat? _format;

        /// <summary>The id of the property type (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("id", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public long? Id
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                    _id = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The name of the property type (required on create)</summary>
        [Newtonsoft.Json.JsonProperty("name", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Name
        {
            get { return _name; }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>A freeform field for grouping properties</summary>
        [Newtonsoft.Json.JsonProperty("group", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Group
        {
            get { return _group; }
            set
            {
                if (_group != value)
                {
                    _group = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("format", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        [Newtonsoft.Json.JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public PropertyTypeFormat? Format
        {
            get { return _format; }
            set
            {
                if (_format != value)
                {
                    _format = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static PropertyType FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<PropertyType>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class Measurement : System.ComponentModel.INotifyPropertyChanged
    {
        private long? _id;
        private long? _measurementTypeId;
        private double? _value;
        private System.Collections.ObjectModel.ObservableCollection<Property> _properties;

        [Newtonsoft.Json.JsonProperty("id", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public long? Id
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                    _id = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The id of the measurement type (required on create)</summary>
        [Newtonsoft.Json.JsonProperty("measurementTypeId", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public long? MeasurementTypeId
        {
            get { return _measurementTypeId; }
            set
            {
                if (_measurementTypeId != value)
                {
                    _measurementTypeId = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The value of the measurement</summary>
        [Newtonsoft.Json.JsonProperty("value", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? Value
        {
            get { return _value; }
            set
            {
                if (_value != value)
                {
                    _value = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The properties recorded in capturing the measurement</summary>
        [Newtonsoft.Json.JsonProperty("properties", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public System.Collections.ObjectModel.ObservableCollection<Property> Properties
        {
            get { return _properties; }
            set
            {
                if (_properties != value)
                {
                    _properties = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static Measurement FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<Measurement>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class Property : System.ComponentModel.INotifyPropertyChanged
    {
        private long? _propertyTypeId;
        private string _value;

        /// <summary>The id of the property type (required on create)</summary>
        [Newtonsoft.Json.JsonProperty("propertyTypeId", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public long? PropertyTypeId
        {
            get { return _propertyTypeId; }
            set
            {
                if (_propertyTypeId != value)
                {
                    _propertyTypeId = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The value of the property</summary>
        [Newtonsoft.Json.JsonProperty("value", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Value
        {
            get { return _value; }
            set
            {
                if (_value != value)
                {
                    _value = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static Property FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<Property>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class MeasurementTypeSummary : System.ComponentModel.INotifyPropertyChanged
    {
        private MeasurementType _measurementType;
        private int? _count;

        /// <summary>The type of the measurement (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("measurementType", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public MeasurementType MeasurementType
        {
            get { return _measurementType; }
            set
            {
                if (_measurementType != value)
                {
                    _measurementType = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>A count of how many instances of this measurement exist in the dataset.  This may not match the session count due to missing data. (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("count", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public int? Count
        {
            get { return _count; }
            set
            {
                if (_count != value)
                {
                    _count = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static MeasurementTypeSummary FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<MeasurementTypeSummary>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class MeasurementType : System.ComponentModel.INotifyPropertyChanged
    {
        private long? _id;
        private string _name;
        private double? _lowerLimit;
        private double? _upperLimit;
        private string _units;

        /// <summary>The id of the measurement (read-only)</summary>
        [Newtonsoft.Json.JsonProperty("id", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public long? Id
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                    _id = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The name of the measurement (required on create)</summary>
        [Newtonsoft.Json.JsonProperty("name", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Name
        {
            get { return _name; }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The lower limit of the measurement</summary>
        [Newtonsoft.Json.JsonProperty("lowerLimit", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? LowerLimit
        {
            get { return _lowerLimit; }
            set
            {
                if (_lowerLimit != value)
                {
                    _lowerLimit = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The upper limit of the measurement</summary>
        [Newtonsoft.Json.JsonProperty("upperLimit", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public double? UpperLimit
        {
            get { return _upperLimit; }
            set
            {
                if (_upperLimit != value)
                {
                    _upperLimit = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>The units the measurement is described in</summary>
        [Newtonsoft.Json.JsonProperty("units", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Units
        {
            get { return _units; }
            set
            {
                if (_units != value)
                {
                    _units = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static MeasurementType FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<MeasurementType>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class DatabaseConfig : System.ComponentModel.INotifyPropertyChanged
    {
        private DatabaseConfigDatabaseType? _databaseType;
        private string _instanceName;
        private string _databaseHostname;
        private int? _databasePort;

        [Newtonsoft.Json.JsonProperty("databaseType", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        [Newtonsoft.Json.JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public DatabaseConfigDatabaseType? DatabaseType
        {
            get { return _databaseType; }
            set
            {
                if (_databaseType != value)
                {
                    _databaseType = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("instanceName", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string InstanceName
        {
            get { return _instanceName; }
            set
            {
                if (_instanceName != value)
                {
                    _instanceName = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("databaseHostname", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string DatabaseHostname
        {
            get { return _databaseHostname; }
            set
            {
                if (_databaseHostname != value)
                {
                    _databaseHostname = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("databasePort", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public int? DatabasePort
        {
            get { return _databasePort; }
            set
            {
                if (_databasePort != value)
                {
                    _databasePort = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static DatabaseConfig FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<DatabaseConfig>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class UserRecord : System.ComponentModel.INotifyPropertyChanged
    {
        private string _identity;
        private string _username;
        private System.DateTime? _lastAccess;

        [Newtonsoft.Json.JsonProperty("identity", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Identity
        {
            get { return _identity; }
            set
            {
                if (_identity != value)
                {
                    _identity = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("username", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Username
        {
            get { return _username; }
            set
            {
                if (_username != value)
                {
                    _username = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("lastAccess", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public System.DateTime? LastAccess
        {
            get { return _lastAccess; }
            set
            {
                if (_lastAccess != value)
                {
                    _lastAccess = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static UserRecord FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<UserRecord>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class User : System.ComponentModel.INotifyPropertyChanged
    {
        private int? _id;
        private string _username;
        private string _password;
        private bool? _isAdmin;

        [Newtonsoft.Json.JsonProperty("id", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public int? Id
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                    _id = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("username", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Username
        {
            get { return _username; }
            set
            {
                if (_username != value)
                {
                    _username = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("password", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Password
        {
            get { return _password; }
            set
            {
                if (_password != value)
                {
                    _password = value;
                    RaisePropertyChanged();
                }
            }
        }

        [Newtonsoft.Json.JsonProperty("isAdmin", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public bool? IsAdmin
        {
            get { return _isAdmin; }
            set
            {
                if (_isAdmin != value)
                {
                    _isAdmin = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static User FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<User>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [Newtonsoft.Json.JsonObject(Newtonsoft.Json.MemberSerialization.OptIn)]
    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public partial class UsernamePasswordCredentials : System.ComponentModel.INotifyPropertyChanged
    {
        private string _username;
        private string _password;

        /// <summary>Username of the user</summary>
        [Newtonsoft.Json.JsonProperty("username", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Username
        {
            get { return _username; }
            set
            {
                if (_username != value)
                {
                    _username = value;
                    RaisePropertyChanged();
                }
            }
        }

        /// <summary>Password of the user</summary>
        [Newtonsoft.Json.JsonProperty("password", Required = Newtonsoft.Json.Required.Default, NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore)]
        public string Password
        {
            get { return _password; }
            set
            {
                if (_password != value)
                {
                    _password = value;
                    RaisePropertyChanged();
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        public string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this);
        }

        public static UsernamePasswordCredentials FromJson(string data)
        {
            return Newtonsoft.Json.JsonConvert.DeserializeObject<UsernamePasswordCredentials>(data);
        }

        protected virtual void RaisePropertyChanged([System.Runtime.CompilerServices.CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
        }
    }

    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public enum PropertyTypeFormat
    {
        [System.Runtime.Serialization.EnumMember(Value = "DateTime")]
        DateTime = 0,

        [System.Runtime.Serialization.EnumMember(Value = "Decimal")]
        Decimal = 1,

        [System.Runtime.Serialization.EnumMember(Value = "Integer")]
        Integer = 2,

        [System.Runtime.Serialization.EnumMember(Value = "Text")]
        Text = 3,

        [System.Runtime.Serialization.EnumMember(Value = "Version")]
        Version = 4,

        [System.Runtime.Serialization.EnumMember(Value = "Boolean")]
        Boolean = 5,

    }

    [System.CodeDom.Compiler.GeneratedCode("NJsonSchema", "7.3.6214.20986")]
    public enum DatabaseConfigDatabaseType
    {
        [System.Runtime.Serialization.EnumMember(Value = "File")]
        File = 0,

        [System.Runtime.Serialization.EnumMember(Value = "SqlExpress")]
        SqlExpress = 1,

    }

    [System.CodeDom.Compiler.GeneratedCode("NSwag", "8.5.6214.25340")]
    public class SwaggerException : System.Exception
    {
        public string StatusCode { get; private set; }

        public byte[] ResponseData { get; private set; }

        public SwaggerException(string message, string statusCode, byte[] responseData, System.Exception innerException)
            : base(message, innerException)
        {
            StatusCode = statusCode;
            ResponseData = responseData;
        }

        public override string ToString()
        {
            return string.Format("HTTP Response: n{0}n{1}", System.Text.Encoding.UTF8.GetString(ResponseData, 0, ResponseData.Length), base.ToString());
        }
    }

    [System.CodeDom.Compiler.GeneratedCode("NSwag", "8.5.6214.25340")]
    public class SwaggerException<TResponse> : SwaggerException
    {
        public TResponse Response { get; private set; }

        public SwaggerException(string message, string statusCode, byte[] responseData, TResponse response, System.Exception innerException)
            : base(message, statusCode, responseData, innerException)
        {
            Response = response;
        }
    }

}